Package org.jboss.resteasy.spi

## Interface Registry

- All Known Implementing Classes:
    `ResourceMethodRegistry`, `VertxRegistry`

      public interface Registry

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addJndiResource​(String jndiName)` | Add a JAX-RS endpoint that exists in JNDI.
    `void` | `addJndiResource​(String jndiName, String basePath)` | Add a JAX-RS endpoint that exists in JNDI.
    `void` | `addJndiResource​(String jndiName, ResourceClass resourceClass)` |
    `void` | `addJndiResource​(String jndiName, ResourceClass resourceClass, String basePath)` |
    `void` | `addPerRequestResource​(Class<?> clazz)` | Add a JAX-RS endpoint.
    `void` | `addPerRequestResource​(Class<?> clazz, String basePath)` | Add a JAX-RS endpoint.
    `default void` | `addPerRequestResource​(Class<?> clazz, ResourceBuilder resourceBuilder)` |
    `void` | `addPerRequestResource​(ResourceClass clazz)` |
    `void` | `addPerRequestResource​(ResourceClass clazz, String basePath)` |
    `void` | `addResourceFactory​(ResourceFactory ref)` | Add a custom resource implementation endpoint.
    `void` | `addResourceFactory​(ResourceFactory ref, String basePath)` | Add a custom resource implementation endpoint.
    `void` | `addResourceFactory​(ResourceFactory ref, String base, Class<?> clazz)` | ResourceFactory.getScannableClass() is not used, only the clazz parameter and not any implemented interfaces of the clazz parameter.
    `void` | `addResourceFactory​(ResourceFactory ref, String base, Class<?>[] classes)` |
    `void` | `addResourceFactory​(ResourceFactory rf, String base, ResourceClass resourceClass)` |
    `default void` | `addResourceFactory​(ResourceFactory ref, ResourceBuilder resourceBuilder)` |
    `default void` | `addResourceFactory​(ResourceFactory ref, ResourceBuilder resourceBuilder, String basePath)` |
    `default void` | `addResourceFactory​(ResourceFactory ref, ResourceBuilder resourceBuilder, String base, Class<?> clazz)` |
    `default void` | `addResourceFactory​(ResourceFactory ref, ResourceBuilder resourceBuilder, String base, Class<?>[] classes)` |
    `void` | `addSingletonResource​(Object singleton)` | Add a JAX-RS endpoint.
    `void` | `addSingletonResource​(Object singleton, String basePath)` | Add a JAX-RS endpoint.
    `void` | `addSingletonResource​(Object singleton, ResourceClass resourceClass)` |
    `void` | `addSingletonResource​(Object singleton, ResourceClass resourceClass, String basePath)` |
    `void` | `checkAmbiguousUri()` |
    `ResourceInvoker` | `getResourceInvoker​(HttpRequest request)` |
    `int` | `getSize()` |
    `void` | `removeRegistrations​(Class<?> clazz)` |
    `void` | `removeRegistrations​(Class<?> clazz, String base)` |
    `void` | `removeRegistrations​(ResourceClass resourceClass)` |

- - ### Method Detail

    - #### addPerRequestResource

          void addPerRequestResource​(Class<?> clazz)

      Add a JAX-RS endpoint. Objects of clazz will be created and destroy and the beginning/end of every request.
      Parameters:
        `clazz` - class

    - #### addPerRequestResource

          default void addPerRequestResource​(Class<?> clazz,
                                             ResourceBuilder resourceBuilder)

    - #### addPerRequestResource

          void addPerRequestResource​(Class<?> clazz,
                                     String basePath)

      Add a JAX-RS endpoint. Objects of clazz will be created and destroy and the beginning/end of every request.
      Parameters:
        `clazz` - class
        `basePath` - prefix path of resource

    - #### addSingletonResource

          void addSingletonResource​(Object singleton)

      Add a JAX-RS endpoint.
      Parameters:
        `singleton` - resource

    - #### addSingletonResource

          void addSingletonResource​(Object singleton,
                                    String basePath)

      Add a JAX-RS endpoint.
      Parameters:
        `singleton` - resource
        `basePath` - prefix path of resource

    - #### addJndiResource

          void addJndiResource​(String jndiName)

      Add a JAX-RS endpoint that exists in JNDI.
      Parameters:
        `jndiName` - JNDI name

    - #### addJndiResource

          void addJndiResource​(String jndiName,
                               String basePath)

      Add a JAX-RS endpoint that exists in JNDI.
      Parameters:
        `jndiName` - JNDI name
        `basePath` - prefix path of resource

    - #### addResourceFactory

          void addResourceFactory​(ResourceFactory ref)

      Add a custom resource implementation endpoint.
      Parameters:
        `ref` - resource factory

    - #### addResourceFactory

          default void addResourceFactory​(ResourceFactory ref,
                                          ResourceBuilder resourceBuilder)

    - #### addResourceFactory

          void addResourceFactory​(ResourceFactory ref,
                                  String basePath)

      Add a custom resource implementation endpoint.
      Parameters:
        `ref` - resource factory
        `basePath` - prefix path of resource

    - #### addResourceFactory

          default void addResourceFactory​(ResourceFactory ref,
                                          ResourceBuilder resourceBuilder,
                                          String basePath)

    - #### addResourceFactory

          void addResourceFactory​(ResourceFactory ref,
                                  String base,
                                  Class<?> clazz)

      ResourceFactory.getScannableClass() is not used, only the clazz parameter and not any implemented interfaces of the clazz parameter.
      Parameters:
        `ref` - resource factory
        `base` - base URI path for any resources provided by the factory, in addition to rootPath
        `clazz` - specific class

    - #### addResourceFactory

          default void addResourceFactory​(ResourceFactory ref,
                                          ResourceBuilder resourceBuilder,
                                          String base,
                                          Class<?> clazz)

    - #### addResourceFactory

          void addResourceFactory​(ResourceFactory ref,
                                  String base,
                                  Class<?>[] classes)

    - #### addResourceFactory

          default void addResourceFactory​(ResourceFactory ref,
                                          ResourceBuilder resourceBuilder,
                                          String base,
                                          Class<?>[] classes)

    - #### removeRegistrations

          void removeRegistrations​(Class<?> clazz)

    - #### removeRegistrations

          void removeRegistrations​(Class<?> clazz,
                                   String base)

    - #### getSize

          int getSize()

    - #### getResourceInvoker

          ResourceInvoker getResourceInvoker​(HttpRequest request)

    - #### addResourceFactory

          void addResourceFactory​(ResourceFactory rf,
                                  String base,
                                  ResourceClass resourceClass)

    - #### removeRegistrations

          void removeRegistrations​(ResourceClass resourceClass)

    - #### addPerRequestResource

          void addPerRequestResource​(ResourceClass clazz)

    - #### addPerRequestResource

          void addPerRequestResource​(ResourceClass clazz,
                                     String basePath)

    - #### addSingletonResource

          void addSingletonResource​(Object singleton,
                                    ResourceClass resourceClass)

    - #### addSingletonResource

          void addSingletonResource​(Object singleton,
                                    ResourceClass resourceClass,
                                    String basePath)

    - #### addJndiResource

          void addJndiResource​(String jndiName,
                               ResourceClass resourceClass)

    - #### addJndiResource

          void addJndiResource​(String jndiName,
                               ResourceClass resourceClass,
                               String basePath)

    - #### checkAmbiguousUri

          void checkAmbiguousUri()